var dictFile = "/usr/share/dict/web2";

function setup()
{
  createGenericButton(document.getElementById("doneButton"), "Done", hidePrefs, 30);
  createGenericButton(document.getElementById("defaultsButton"), "Reset to default", resetToDefaults, 67);
    
  if(window.widget)
	{
	  var tempDictFile = widget.preferenceForKey("dictFile");
  	if(worldString && worldString.length > 0)
	  {
	    dictFile = widget.preferenceForKey("dictFile");
		}
		else
		{
	    widget.setPreferenceForKey("/usr/share/dict/web2", "dictFile");
		}
  }
}

function findMatches(f)
{
	var obj = widget.system("grep -ai \"^" + f.value + "$\" \"" + dictFile + "\" | head -50", null);
	var stringResult = obj.outputString;
	if(stringResult)
	{
		var charsPerLine = (f.value.length+1) * Math.floor(22/(f.value.length+1));
		var maxChars = 10 * charsPerLine;
		if(stringResult.length > maxChars)
			printResults(stringResult.substring(0, maxChars-4).toUpperCase() + "...");
		else
			printResults(stringResult.toUpperCase());
	}
	else
		printResults("No matches found.");
}

function printResults(s)
{
	var newSpan = document.createElement("span");
	newSpan.id = "resultTextSpan";
	var newText = document.createTextNode(s);
	newSpan.appendChild(newText);
	var resultText		= document.getElementById("resultText");
	var resultTextSpan	= document.getElementById("resultTextSpan");
	var replaced = resultText.replaceChild(newSpan, resultTextSpan);
}

function loadPreferences()
{
    document.getElementById("dictInput").value = dictFile;
}

function dictKeyPress (event)
{
	switch (event.keyCode)
	{
		case 13: // return
		case 3:  // enter
		case 9:  // tab
			dictChanged();
			break;
	}
}

function dictChanged()
{
	if(window.widget)
	{
		var newDict = document.getElementById('dictInput').value
		//TODO: check file exists (and even check is of right type)
		var dictValid = false;
		//first, check file exists
		var obj = widget.system("test -r \"" + newDict + "\" && echo \"exists\"", null);
		if(!(obj.outputString) || obj.outputString == "")
			printResults("The specified dictionary file does not appear to exist.");
		else
		{
			var obj2 = widget.system("file \"" + newDict + "\" | grep -q \"terminators\" || echo \"unix\"", null);
			if(!(obj2.outputString) || obj2.outputString == "")
				printResults("The specified dictionary file appears to not have UNIX line endings. You may need to convert it to UNIX line endings first.");
			else
				dictValid = true;
		}
		widget.setPreferenceForKey(newDict, "dictFile");
		dictFile = newDict;
		
		if(dictValid)
			findMatches(document.getElementById("textEntry"));
	}
}

function resetToDefaults()
{
	if(window.widget)
	{
		dictFile = "/usr/share/dict/web2";
		loadPreferences();
	}
}

function wrapURL(URL)
{
    if(window.widget)
        widget.openURL(URL);
    else
        window.location = URL;
}

function executeSystemCommand(cmd)
{
    widget.system(cmd + " > /tmp/XWordWidgetOutput.txt", null);
    var out = readInFile("/tmp/XWordWidgetOutput.txt");
    widget.system("rm /tmp/XWordWidgetOutput.txt", null);
    return out;
}

function readInFile(filename)
{
    var req = new XMLHttpRequest();
    req.open("GET", filename, false);
	req.send(null);
	var response = req.responseText;
	if(response)
	{
		return response;
	}
	return null;
}